double norm(double* vector,int len){
    double n=0;
    for(int i=0;i<len;i++){
        n+=pow(vector[i],2);
    }
    return sqrt(n);
}

void matmult(double* Asq,double* B,double *C,int len12,int len3){
    for(int j=0;j<len3;j++){
        for(int i=0;i<len12;i++){
            C[i+j*len12]=0.0;
            for(int k=0;k<len12;k++){
                C[i+j*len12]+=Asq[i+k*len12]*B[k+j*len12];
            }
        }
    }
}

void inv2D(double* Ainv,double* A){
    double det1=1.0/(A[0]*A[3]-A[1]*A[2]);
    Ainv[0]=det1*A[3]; Ainv[2]=-det1*A[2];
    Ainv[1]=-det1*A[1]; Ainv[3]=det1*A[0];
}


double dotprod(double* vector,double* vector2,int len){
    double dot=0;
    for(int i=0;i<len;i++){
        dot+=vector[i]*vector2[i];
    }
    return dot;
}


double dotprodT(double* sqmatrix,double* vector,int len1,int len){
    double dot=0;
    for(int i=0;i<len1;i++){
        dot+=sqmatrix[i*len]*vector[i];
    }
    return dot;
}
void qrInv(double* Q,double* X,double* A,int len){
    //QR decompostion and inverse for square matrices
    double* R=Q+len*len;
    double* b=Q+len*len*2;
    
    for(int i=0;i<len*len;i++){
        Q[i]=0.0; R[i]=0.0;
    }
    
    //first column
    R[0+0*len]=norm(A,len);
    for(int i=0;i<len;i++){
        Q[i]=A[i]/R[0+0*len];
    }
    for(int c2=1;c2<len;c2++){ //for all other columns
        R[0+c2*len]=dotprod(Q,A+len*c2,len);
    }
    for(int c1=1;c1<len;c1++){ //for each column
        //c-th column
        //second column - misuse Q(:,2:4) for a2,a3,a4
        for(int i=0;i<len;i++){
            for(int c2=c1;c2<len;c2++){
                Q[i+len*c2]=A[i+len*c2]-dotprodT(Q+i,R+c2*len,c1,len);
            }
        }
        R[c1+c1*len]=norm(Q+len*c1,len);
        for(int i=0;i<len;i++){
            Q[i+len*c1]=Q[i+len*c1]/R[c1+c1*len];
        }
        for(int c2=c1+1;c2<len;c2++){
            
            R[c1+c2*len]=dotprod(Q+len*c1,A+len*c2,len);
            R[c1+c2*len]=dotprod(Q+len*c1,A+len*c2,len);
        }
        
    }//end of c-th column
    for(int j=0;j<len;j++){
        //resubtitution for solving Ax=b
        for(int i=0;i<len;i++){
            X[i+j*len]=0;
            b[i]=0.0;
        }
        b[j]=1.0;
        for(int c1=len-1;c1>=0;c1--){
            double d1=dotprod(Q+len*c1,b,len);
            double rdot=0;
            for(int c2=c1+1;c2<len;c2++){
                rdot+=R[c1+c2*len]*X[c2+j*len];
            }
            X[c1+j*len]=(d1-rdot)/R[c1+c1*len];
        }
    }
    
}
